// SignalDetector.h: interface for the SignalDetector class.
//
/*	
	Copyright 2006-2007 Zednek Kotolan (Mazarikova Univerzita)

	This research work is co-founded by the European Commission under the Leonardo framework (V3 project, agreement
	number B/05/B/F/PP-144.005, http://www.leonardo-v3.eu).  V3, which stands for "Versatile and educational Vocational
	training Vehicle", is aiming at designing, implementing, deploying, evaluating and exploiting a versatile, 
	userfriendly, ICT-based Vocational and Educational Training (VET) framework suited for both young people in initial
	training as well as adult in lifelong learning activities.
	The V3 project partnership is composed of : 
		- Facults Universitaires Notre-Dame de la Paix (Namur, Belgium)
		- ICN groupe (Nancy, France)
		- Centre de Recherche Public Henri Tudor (Luxemburg)
		- Universitt Bremen (Bremen, Germany)
		- EMMERCE EEIG (Sweden)
		- Masarykova Univerzita (Brno, Czech Republic)

	This source code is licensed under Open Software license v3.0.  You can find a copy of this license at the 
	following URL : http://www.opensource.org/licenses/osl-3.0.php.  This notice has to be retained in all derived works.

*/

#if !defined(AFX_SIGNALDETECTOR_H__B4B9CF06_B948_49A5_9145_ECB3E318BF05__INCLUDED_)
#define AFX_SIGNALDETECTOR_H__B4B9CF06_B948_49A5_9145_ECB3E318BF05__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "buffer.h"

class CSignalDetector  
{
public:
	CSignalDetector();
	virtual ~CSignalDetector();

	void SetSignalTrue();

    void SetRecordingParams(int in_SamplingRate, int in_Channels, int in_BPS);

	void SetDetector(int in_BufferLength);
	void SetThreshold(double in_Threshold);

	void ProcessBuffer(CBuffer* buffer);
	bool IsSignalDetected();

	float GetActualMean();
    
//	bool   IsSignal;

private:
	float* Buffer;
	bool   IsSignal;
	int    BufferLength;
	bool   BufferIsCreated;
	bool   BufferFull;
	int    BufferPointer;
    int    SamplingRate;
	int    Channels;
	int    BPS;
	double Threshold; 

	void FreeBuffer();
	void WriteToBuffer(float Mean);
};

#endif // !defined(AFX_SIGNALDETECTOR_H__B4B9CF06_B948_49A5_9145_ECB3E318BF05__INCLUDED_)
