// MouseHook.cpp : Defines the entry point for the DLL application.
//
/*	
	RenderSoft CamStudio :
		Copyright 2001 - 2003 RenderSoft Software & Web Publishing

	Modifications of RenderSoft CamStudio implemented under V3 project :
		Copyright 2006-2007 Geoffrey Miche <gmi@info.fundp.ac.be> (Facults Universitaires Notre-Dame de la Paix)

	This research work is co-founded by the European Commission under the Leonardo framework (V3 project, agreement
	number B/05/B/F/PP-144.005, http://www.leonardo-v3.eu).  V3, which stands for "Versatile and educational Vocational
	training Vehicle", is aiming at designing, implementing, deploying, evaluating and exploiting a versatile, 
	userfriendly, ICT-based Vocational and Educational Training (VET) framework suited for both young people in initial
	training as well as adult in lifelong learning activities.
	The V3 project partnership is composed of : 
		- Facults Universitaires Notre-Dame de la Paix (Namur, Belgium)
		- ICN groupe (Nancy, France)
		- Centre de Recherche Public Henri Tudor (Luxemburg)
		- Universitt Bremen (Bremen, Germany)
		- EMMERCE EEIG (Sweden)
		- Masarykova Univerzita (Brno, Czech Republic)

	This source code is licenced under Open Software Licence v3.0.  You can find a copy of this licence at the 
	following URL : http://www.opensource.org/licences/osl-3.0.php.
*/


#include "stdafx.h"
#define _COMPILING_44E531B1_14D3_11d5_A025_006067718D04
#include "Hook.h"
#include <stdio.h>
#include <mmsystem.h>

#pragma data_seg(".SHARE")
HWND hWndServer = NULL;
UINT nMsg = 0;
HHOOK hook = NULL;
unsigned long oldKeyMouseTime = 0;
#pragma data_seg()
#pragma comment(linker, "/section:.SHARE,rws")

HINSTANCE hInst;


UINT WM_USER_RECORDINTERRUPTED;
UINT WM_USER_STOP;
UINT WM_USER_SAVECURSOR;
UINT WM_USER_GENERIC;
UINT WM_USER_RECORDSTART;


static LRESULT CALLBACK hookproc(UINT nCode, WPARAM wParam, LPARAM lParam);

BOOL APIENTRY DllMain( HINSTANCE hInstance, 
                       DWORD  Reason, 
                       LPVOID Reserved
					 )
{
 switch(Reason)
    { /* reason */
     case DLL_PROCESS_ATTACH:
	hInst = hInstance;
	WM_USER_RECORDINTERRUPTED = RegisterWindowMessage(WM_USER_RECORDINTERRUPTED_MSG);
	WM_USER_STOP = RegisterWindowMessage(WM_USER_STOP_MSG);
			WM_USER_SAVECURSOR = RegisterWindowMessage(WM_USER_SAVECURSOR_MSG);
			WM_USER_GENERIC = RegisterWindowMessage(WM_USER_GENERIC_MSG);
			WM_USER_RECORDSTART = RegisterWindowMessage(WM_USER_RECORDSTART_MSG);
	return TRUE;
     case DLL_PROCESS_DETACH:
	if(hWndServer != NULL)
	   UninstallMyHook(hWndServer);
	return TRUE;
    } /* reason */
    return TRUE;
}


__declspec(dllexport) BOOL InstallMyHook(HWND hWnd, UINT message_to_call)
    {
     if(hWndServer != NULL)
	return FALSE; // already hooked!
     hook = SetWindowsHookEx(WH_GETMESSAGE,
			    (HOOKPROC)hookproc,
			    hInst,
			    0);
     if(hook != NULL)
	{ /* success */
	 hWndServer = hWnd;
	 nMsg = message_to_call;
	 
	 return TRUE;
	} /* success */
     return FALSE; // failed to set hook
    } // setMyHook


__declspec(dllexport) BOOL UninstallMyHook(HWND hWnd)
    {
     if(hWnd != hWndServer || hWnd == NULL)
	return FALSE;
     BOOL unhooked = UnhookWindowsHookEx(hook);
     if(unhooked)
	hWndServer = NULL;
     return unhooked;
    } // clearMyHook



static LRESULT CALLBACK hookproc(UINT nCode, WPARAM wParam, LPARAM lParam)
{
    if(nCode < 0)
	{ /* pass it on */
	 CallNextHookEx(hook, nCode, wParam, lParam);
	 return 0;
	} /* pass it on */
     
	 
	 LPMSG msg = (LPMSG)lParam;     
	

	 //ver 1.2
	 if(msg->message == WM_MOUSEMOVE || msg->message == WM_NCMOUSEMOVE || msg->message == WM_LBUTTONDOWN || (msg->message == WM_LBUTTONUP)) {

		 unsigned long currentKeyMouseTime = timeGetTime();
		 unsigned long difftime = currentKeyMouseTime - oldKeyMouseTime;
		 if (difftime>20) {	//up to 50 frames per second	 

			HCURSOR hcur= GetCursor();		 		 
			PostMessage(hWndServer, WM_USER_SAVECURSOR , (unsigned int) hcur, msg->message);
			oldKeyMouseTime = currentKeyMouseTime;
		 
		 }
		 

	 } 	 	 
	 
     return CallNextHookEx(hook, nCode, wParam, lParam);    
    
} 
