'	
'	Copyright 2006-2007 Geoffrey Miche <gmi@info.fundp.ac.be> (Facults Universitaires Notre-Dame de la Paix)
'                       Kaled Hadj Belgacem (Cogelis - ICN Business School)
'
'	This research work is co-founded by the European Commission under the Leonardo framework (V3 project, agreement
'	number B/05/B/F/PP-144.005, http://www.leonardo-v3.eu).  V3, which stands for "Versatile and educational Vocational
'	training Vehicle", is aiming at designing, implementing, deploying, evaluating and exploiting a versatile, 
'	userfriendly, ICT-based Vocational and Educational Training (VET) framework suited for both young people in initial
'	training as well as adult in lifelong learning activities.
'	The V3 project partnership is composed of : 
'		- Facults Universitaires Notre-Dame de la Paix (Namur, Belgium)
'		- ICN groupe (Nancy, France)
'		- Centre de Recherche Public Henri Tudor (Luxemburg)
'		- Universitt Bremen (Bremen, Germany)
'		- EMMERCE EEIG (Sweden)
'		- Masarykova Univerzita (Brno, Czech Republic)
'
'	This source code is licensed under Open Software license v3.0.  You can find a copy of this license at the 
'	following URL : http://www.opensource.org/licenses/osl-3.0.php.  This notice has to be retained in all derived works.
'

Imports Microsoft.Office.Core
Imports Microsoft.Office.Core.MsoTriState
Imports Microsoft.Office.Core.MsoControlType
Imports Microsoft.Office.Core.MsoButtonStyle
Imports Microsoft.Office.Core.MsoFileDialogType
Imports Microsoft.Office.Core.MsoFileDialogView
Imports Microsoft.Office.Interop
Imports Microsoft.Office.Interop.PowerPoint.PpSlideLayout
Imports Extensibility
Imports System.Runtime.InteropServices
Imports Microsoft.Win32

#Region " Read me for Add-in installation and setup information. "
' When run, the Add-in wizard prepared the registry for the Add-in.
' At a later time, if the Add-in becomes unavailable for reasons such as:
'   1) You moved this project to a computer other than which is was originally created on.
'   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.
'   3) Registry corruption.
' you will need to re-register the Add-in by building the $SAFEOBJNAME$Setup project, 
' right click the project in the Solution Explorer, then choose install.
#End Region

<GuidAttribute("E98387F3-F2DE-47EC-AF49-EAA4DB456DC7"), ProgIdAttribute("V3Capture.Connect")> _
Public Class Connect

    Implements Extensibility.IDTExtensibility2

    Dim addInInstance As Object
    Dim applicationObject As Object 'Application PowerPoint
    Dim WithEvents objCommandBarButton As CommandBarButton      'Bouton ajout par le modul
    Dim WithEvents powerapp As PowerPoint.Application
    Dim EnrgistrerFichier As Boolean = False

    Dim prcCamStudio As New System.Diagnostics.Process 'Processus attribu  CamStudio

    Public Sub OnBeginShutdown(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnBeginShutdown
        objCommandBarButton.Delete()
    End Sub

    Public Sub OnAddInsUpdate(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnAddInsUpdate
    End Sub

#Region " => Cration, connexion du composant "

    Public Sub OnStartupComplete(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnStartupComplete
        Dim objCommandBars As CommandBars
        Dim objCommandBar As CommandBar
        Dim oStandardBar As CommandBar 'Pour le bouton
        Dim objCommandBarControl As CommandBarControl
        'Rcup des barres d'outils Powerpoint
        'MsgBox("Before creating menu")
        objCommandBars = applicationObject.CommandBars

        '----- MENU OUTILS -----
        ' Cre une commande de menu dans le menu Outils.
        objCommandBar = objCommandBars.Item("Tools")

        ' Assurez-vous que la commande de menu n'existe pas dj.
        For Each objCommandBarControl In objCommandBar.Controls
            If objCommandBarControl.Caption = "V3 Capture" Then
                objCommandBar.Controls.Item("V3 Capture").Delete()
            End If
        Next (objCommandBarControl)

        objCommandBarButton = objCommandBar.Controls.Add(msoControlButton)

        With (objCommandBarButton)
            .Caption = "V3 Capture"
            .Style = msoButtonCaption
            .Tag = "V3 Capture"
            .OnAction = "!<PowerPointAddIn.Connect>"
            .Visible = True
        End With
        'MsgBox("before creating bar")
        '----- BARRE D'OUTILS STANDARD -----
        ' Cre le bouton dans la barre d'outils.
        oStandardBar = objCommandBars.Item("Standard")

        For Each objCommandBarControl In oStandardBar.Controls
            If objCommandBarControl.Caption = "V3 Capture" Then
                objCommandBar.Controls.Item("V3 Capture").Delete()
            End If
        Next (objCommandBarControl)

        objCommandBarButton = oStandardBar.Controls.Add(1)

        With objCommandBarButton
            .Caption = "V3 Capture"
            .Style = MsoButtonStyle.msoButtonCaption
            .Tag = "V3 Capture"
            .OnAction = "!<PowerPointAddIn.Connect>"
            .Visible = True
        End With
    End Sub

    Public Sub OnDisconnection(ByVal RemoveMode As Extensibility.ext_DisconnectMode, ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnDisconnection
        On Error Resume Next

        ' Dconnectez le complment partag, quelle que soit la faon dont l'application a t ferme. 
        If RemoveMode <> Extensibility.ext_DisconnectMode.ext_dm_HostShutdown Then Call OnBeginShutdown(custom)

        applicationObject = Nothing

    End Sub

    Public Sub OnConnection(ByVal application As Object, ByVal connectMode As Extensibility.ext_ConnectMode, ByVal addInInst As Object, ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnConnection
        'MsgBox("Connect created")
        applicationObject = application
        addInInstance = addInInst
        powerapp = application
        ' Quelle que soit la faon dont l'application hte a t dmarre, connectez le complment partag.
        If (connectMode <> Extensibility.ext_ConnectMode.ext_cm_Startup) Then Call OnStartupComplete(custom)

    End Sub

#End Region

#Region " => Action sur le composant "

    Private Sub objCommandBarButton_Click(ByVal Ctrl As CommandBarButton, ByRef CancelDefault As Boolean) Handles objCommandBarButton.Click
        If (objCom Is Nothing) Then
            'Passage en mode enregistrement
            EnrgistrerFichier = True
            'Vrifier si le chemin de CamStudio a t modifi
            CamStudioPath = Registry.LocalMachine.OpenSubKey("SOFTWARE").OpenSubKey("CamStudio+").OpenSubKey("InstallPath").GetValue("InstallPath") & "\CamStudio+.exe"
            'Dmarrage du processus CamStudio
            If System.IO.File.Exists(CamStudioPath) Then
                ' Le fichier existe
                prcCamStudio.StartInfo.FileName = CamStudioPath
            Else
                ' Le fichier n'existe pas
                MsgBox("CamStudio not found (" & CamStudioPath & "). Please launch CamStudio manually.")
            End If
            'Lancer l'coute
            StartListen(applicationObject)
            prcCamStudio.Start()
            'Lancement du diaporama
            'applicationObject.ActivePresentation.SlideShowSettings.Run()
        Else
            MsgBox("V3 Capture is already launched. Please start CamStudio manually or press on CamStudio record button.")
        End If

    End Sub

#End Region

#Region " => Evenements lis au PowerPoint "

    Private Sub applicationObject_SlideShowBegin(ByVal Wn As PowerPoint.SlideShowWindow) Handles powerapp.SlideShowBegin

        If EnrgistrerFichier Then

            Dim sSlideTitle As String
            Dim showpos As Integer

            showpos = Wn.Application.ActivePresentation.Windows.Item(1).Selection.SlideRange.SlideNumber + Wn.View.CurrentShowPosition - 1
            'MsgBox("showpos : " & showpos)

            ' first make sure the slide has a title!
            If applicationObject.ActivePresentation.Slides(showpos).Shapes.HasTitle Then
                sSlideTitle = """" & applicationObject.ActivePresentation.Slides(showpos).Shapes.Title.TextFrame.TextRange.Text.ToString() & """"
            Else
                sSlideTitle = """" & "Slide has no title" & """"
            End If

            Call SSBegin(showpos, sSlideTitle) 'Voir modFonctions

        End If
    End Sub

    Private Sub applicationObject_SlideShowNextSlide(ByVal Wn As PowerPoint.SlideShowWindow) Handles powerapp.SlideShowNextSlide
        'MsgBox("Slide suivant")
        If EnrgistrerFichier Then
            Dim sSlideTitle As String
            Dim showpos As Integer

            showpos = Wn.Application.ActivePresentation.Windows.Item(1).Selection.SlideRange.SlideNumber + Wn.View.CurrentShowPosition - 1
            'MsgBox("showpos next slide: " & showpos)
            ' first make sure the slide has a title!
            If applicationObject.ActivePresentation.Slides(showpos).Shapes.HasTitle Then
                sSlideTitle = """" & applicationObject.ActivePresentation.Slides(showpos).Shapes.Title.TextFrame.TextRange.Text.ToString() & """"
            Else
                sSlideTitle = """" & "Slide #" & showpos & """"
            End If
            If (Not pauseMode) Then
                Call SSNextSlide(showpos, sSlideTitle) 'Voir modFonctions
            End If
        End If
    End Sub

    Private Sub applicationObject_SlideShowEnd(ByVal Pres As PowerPoint.Presentation) Handles powerapp.SlideShowEnd
        'MsgBox("Call stopCapture")
        Call StopCapture()
        Call SSEnd()
        'Arrete la Capture CamStudion Envoi de stop sur le socket
        'On libre les ressources dont on a plus besoin.
        'prcCamStudio.Close() 'Attention Close ne met pas fin au processus.

        If EnrgistrerFichier Then EnrgistrerFichier = False

    End Sub

#End Region

End Class
