'	
'	Copyright 2006-2007 Geoffrey Miche <gmi@info.fundp.ac.be> (Facults Universitaires Notre-Dame de la Paix)
'                       Kaled Hadj Belgacem (Cogelis - ICN Business School)
'
'	This research work is co-founded by the European Commission under the Leonardo framework (V3 project, agreement
'	number B/05/B/F/PP-144.005, http://www.leonardo-v3.eu).  V3, which stands for "Versatile and educational Vocational
'	training Vehicle", is aiming at designing, implementing, deploying, evaluating and exploiting a versatile, 
'	userfriendly, ICT-based Vocational and Educational Training (VET) framework suited for both young people in initial
'	training as well as adult in lifelong learning activities.
'	The V3 project partnership is composed of : 
'		- Facults Universitaires Notre-Dame de la Paix (Namur, Belgium)
'		- ICN groupe (Nancy, France)
'		- Centre de Recherche Public Henri Tudor (Luxemburg)
'		- Universitt Bremen (Bremen, Germany)
'		- EMMERCE EEIG (Sweden)
'		- Masarykova Univerzita (Brno, Czech Republic)
'
'	This source code is licensed under Open Software license v3.0.  You can find a copy of this license at the 
'	following URL : http://www.opensource.org/licenses/osl-3.0.php.  This notice has to be retained in all derived works.

Imports System.Windows.Forms
Imports System.Threading 'Pour les communication socket
Imports Microsoft.Win32
Imports Microsoft.Office.Interop
Imports Microsoft.Office.Core
Imports Microsoft.Office.Core.MsoTriState

Module modFonctions

    '========================================================
    '===== Fonctions d'criture des temps sans le fichier ===
    '========================================================
    Public sTimingFileName As String
    Public sPathTimingInfo As String
    Public HeureDepartSlide As Date
    Dim pauseStartTime As Date

    Dim rkey As RegistryKey = Registry.LocalMachine 'obj pour aller chercher la path de camstudio ds la base de registres
    Public CamStudioPath As String = rkey.OpenSubKey("SOFTWARE").OpenSubKey("CamStudio+").OpenSubKey("InstallPath").GetValue("InstallPath") & "\CamStudio+.exe"  'Path par dfaut destin a etre remplac
    Dim CheminEnreg As String = ""
    Public pauseMode As Boolean = False

    Dim strNomFichierRecu As String = ""

    Sub SSBegin(ByVal lSlideNum As Long, ByVal sSlideTitle As String)

        HeureDepartSlide = Now

        ' Here, we should create a new timing file named by date/time,
        ' and append an entry corresponding to the start time
        Dim oFS As Object
        'Dim fFolderTiming As Object
        Dim fTimingFile As Object
        'Dossier d'enregistrement du fichier 
        Dim sDirectoryTimingInfo As String = Environment.CurrentDirectory '"Dossier personnel de l'utilisateur (temporaire)"

        oFS = CreateObject("Scripting.FileSystemObject")

        ' Based on what's already in the directory, make a new filename.
        Dim sFileNumMax As Date ', sFileNum As String
        'Dim fFile As Object
        sFileNumMax = Now
        'fFolderTiming = oFS.GetFolder(sDirectoryTimingInfo)
        'For Each fFile In fFolderTiming.Files
        'If StrComp(Mid(fFile.Name, 1, 6), "timing") = 0 And StrComp(Mid(fFile.Name, 10, 4), ".log") = 0 Then
        'sFileNum = Mid(fFile.Name, 7, 3)
        'If StrComp(sFileNum, sFileNumMax) Then
        'sFileNumMax = sFileNum
        'End If
        'End If
        'Next

        'sTimingFileName = "timing" & Right("000" & (CInt(Right(sFileNumMax, 3)) + 1), 3) & ".log"
        sTimingFileName = "timing" & DateAndTime.Day(sFileNumMax) & DateAndTime.Month(sFileNumMax) & DateAndTime.Year(sFileNumMax) & "_" & DateAndTime.Hour(sFileNumMax) & DateAndTime.Minute(sFileNumMax) & DateAndTime.Second(sFileNumMax) & ".log"
        sPathTimingInfo = sDirectoryTimingInfo & "\" & sTimingFileName

        fTimingFile = oFS.CreateTextFile(sPathTimingInfo, True, False)
        'fTimingFile.write(TimingHeaderTEMPOTXT(lSlideNum, sSlideTitle))

        ' Here, I should write out stuff like presentation title, etc..
        ' I should generate this output in a separate function,
        ' in case I change the way I do output later (tempo.txt vs. XML, etc)

        fTimingFile.Close()

    End Sub

    Sub SSNextSlide(ByVal lSlideNum As Long, ByVal sSlideTitle As String)

        Const ForAppending As Integer = 8
        Const TristateFalse As Integer = 0

        Dim oFS As Object
        Dim fTimingFile As Object


        oFS = CreateObject("Scripting.FileSystemObject")
        fTimingFile = oFS.OpenTextFile(sPathTimingInfo, ForAppending, True, TristateFalse)

        fTimingFile.write(TimingEntryTEMPOTXT(lSlideNum, sSlideTitle))

        fTimingFile.Close()

    End Sub

    Sub SSEnd()

        Const ForAppending As Integer = 8
        Const TristateFalse As Integer = 0

        Dim oFS As Object
        Dim fFileTimingInfo As Object

        If (pauseMode) Then
            pauseTimeSpent(pauseStartTime, Now)
            pauseMode = False
        End If
        oFS = CreateObject("Scripting.FileSystemObject")
        fFileTimingInfo = oFS.OpenTextFile(sPathTimingInfo, ForAppending, True, TristateFalse)

        fFileTimingInfo.write(TimingFooterTEMPOTXT)

        fFileTimingInfo.Close()
    End Sub

    Sub EndTreatment()

        If strNomFichierRecu = "" Then 'Pas de nom de fichier recu par CamStudio
            'Transfert du fichier vers l'emplacement dsir de l'utilisateur
            Dim FenetreFichier As New FolderBrowserDialog

            FenetreFichier.Description = "Please choose a directory where to save the file."

            If FenetreFichier.ShowDialog() = DialogResult.OK Then
                System.IO.File.Move(sPathTimingInfo, FenetreFichier.SelectedPath & "\" & sTimingFileName)
            End If

        Else
            Try
                'Extraction du chemin d'acces a camstudio (en virant le Recorder.exe du chemin)
                ' = CamStudioPath.Replace(CamStudioPath.Split("\")(CamStudioPath.Split("\").Length - 1), "")
                System.IO.File.Move(sPathTimingInfo, CheminEnreg + CStr(strNomFichierRecu) + ".log")

            Catch ex As Exception
                Dim savein As String = Nothing
                If (Not CheminEnreg.Equals([String].Empty)) Then
                    savein = CheminEnreg & "\" & sTimingFileName
                    System.IO.File.Copy(sPathTimingInfo, savein)
                    'MsgBox(ex.Message, MsgBoxStyle.Exclamation)
                Else
                    savein = sPathTimingInfo
                End If
                MsgBox("Error while saving the file : " & CStr(strNomFichierRecu) & ".log. " & "Message saved in " & CStr(savein), MsgBoxStyle.Exclamation)
            End Try

        End If

        'arreter l'enregistrement ds cam studio

    End Sub

    ' IsFolderWriteable: a function that returns True if it can write to the folder,
    ' otherwise makes an error msgbox and returns False
    Function IsFolderWriteable(ByVal sFolderName As String) As Boolean
        Dim bIsWriteable As Boolean
        Dim oFS As Object
        Dim sOutFilePath As String
        Dim fTestFile As Object

        On Error GoTo IsFolderWriteable_err

        sOutFilePath = sFolderName & "\" & "test.out"

        oFS = CreateObject("Scripting.FileSystemObject")

        'MsgBox "IsFolderWriteable: attempting to open [ " & sOutFilePath & " ]"

        fTestFile = oFS.CreateTextFile(sOutFilePath, True)
        fTestFile.WriteLine("This is a test.")
        fTestFile.Close()

        'MsgBox "IsFolderWriteable: attempting to delete test file"

        oFS.DeleteFile(sOutFilePath)

        IsFolderWriteable = True

        Exit Function

IsFolderWriteable_err:
        IsFolderWriteable = False
        MsgBox("Error: Cannot write to that folder" & vbCrLf & Err.Number & ": " & Err.Description)

    End Function

    'Function TimingHeaderTEMPOTXT(ByVal lSlideNum As Long, ByVal sSlideTitle As String)
    'TimingHeaderTEMPOTXT = TimingEntryTEMPOTXT(0, "BEGIN")
    'End Function

    Function TimingEntryTEMPOTXT(ByVal lSlideNum As Long, ByVal sSlideTitle As String) As String

        'calcul du temps depuis de dbut
        Dim time As Long = 0
        Dim treatTime As Long = 0

        TimingEntryTEMPOTXT = ""
        time = DateDiff(DateInterval.Second, HeureDepartSlide, Now)

        For i As Integer = 1 To 3
            If (time > 0) Then
                treatTime = time Mod 60
                time = (time - treatTime) / 60
            Else
                treatTime = 0
            End If
            TimingEntryTEMPOTXT = IIf(CStr(treatTime).Length = 1, "0" & treatTime, treatTime) & IIf((i <> 1), ":", "") & TimingEntryTEMPOTXT
        Next i

        If (lSlideNum = 0) Then
            TimingEntryTEMPOTXT = TimingEntryTEMPOTXT & " " & sSlideTitle & vbCrLf
        Else
            TimingEntryTEMPOTXT = TimingEntryTEMPOTXT & " " & lSlideNum & " " & sSlideTitle & vbCrLf
        End If
    End Function

    Function TimingFooterTEMPOTXT() As String
        TimingFooterTEMPOTXT = TimingEntryTEMPOTXT(0, "END")
    End Function

    Sub pauseTimeSpent(ByVal pauseStartTime As Date, ByVal pauseStopTime As Date)
        Dim hour, min, sec As Long
        hour = DateDiff(DateInterval.Hour, pauseStartTime, pauseStopTime)
        min = DateDiff(DateInterval.Minute, pauseStartTime, pauseStopTime) - (hour * 60)
        sec = DateDiff(DateInterval.Second, pauseStartTime, pauseStopTime) - (hour * 3600 + min * 60)
        HeureDepartSlide = HeureDepartSlide.AddSeconds(sec)
        HeureDepartSlide = HeureDepartSlide.AddMinutes(min)
        HeureDepartSlide = HeureDepartSlide.AddHours(hour)
    End Sub
    '========================================================
    '===== Fonction de communication Sockets ac CamStudio ===
    '========================================================
    Dim objPpt As PowerPoint.Application
    Public objCom As ComSocketUdp
    Public t As Thread

    Sub ThreadProc()
        'Thread d'coute pricipal des signaux envoys par CamStudio
        Dim reception As String = Nothing

        Try
            While (Thread.CurrentThread.ThreadState <> ThreadState.Aborted _
                        And Thread.CurrentThread.ThreadState <> ThreadState.AbortRequested _
                        And Thread.CurrentThread.ThreadState <> ThreadState.Suspended)
                reception = objCom.Recevoir()
                If Not reception Is Nothing Then
                    'Parsing du message recu spar par des #
                    Dim tabReception() As String

                    tabReception = reception.Split("#")
                    If tabReception.Length > 1 Then 'C'est qu'il y a des infos supplmentaires
                        CheminEnreg = tabReception(0) & "\"
                        strNomFichierRecu = tabReception(1)

                        'MsgBox(strNomFichierRecu & " || CheminEnreg = " & CheminEnreg)
                        'MsgBox("CheminEnreg = " & CheminEnreg & " || CamStudioPath = " & CamStudioPath)

                    End If

                    If (String.Compare(reception, "start") = 0) Then
                        With objPpt.ActivePresentation.SlideShowSettings
                            .RangeType = PowerPoint.PpSlideShowRangeType.ppShowSlideRange
                            .StartingSlide = objPpt.Windows.Item(1).Selection.SlideRange.SlideNumber
                            .EndingSlide = objPpt.ActivePresentation.Slides.Count
                            .Run()
                        End With
                        objCom.Envoyer("slideshow")
                    ElseIf (String.Compare(reception, "error") = 0) Then
                        'txtConsole.AppendText(vbCrLf & "Message start reu de CamStudio")
                        'lblEtat.Text = "Start - Capture en cours..."
                    ElseIf (String.Compare(reception, "pause") = 0) Then
                        pauseMode = True
                        pauseStartTime = Now
                    ElseIf (String.Compare(reception, "endpause") = 0) Then
                        pauseMode = False
                        pauseTimeSpent(pauseStartTime, Now)
                        'ElseIf (String.Compare(reception, "stopconfirmed") = 0) Then
                        'Call SSEnd()
                    Else
                        'MsgBox("avant l'appel  SSend")
                        Call EndTreatment() 'Appelle la fin du fichier texte dans lequel se passe l'enregistrement du fichier
                        ' MsgBox("aprs l'appel  SSend et avant l'appel  Closing")
                        Call Closing() 'Met fin au thread d'coute
                        'MsgBox("aprs l'appel  closing")
                    End If
                End If

            End While
        Catch ex As ThreadAbortException
            objCom.Dispose()
            objCom = Nothing
        End Try
    End Sub

    Sub StartListen(ByVal inAppliPpt As PowerPoint.Application)
        objPpt = inAppliPpt
        'initialisation des paramtres de communication
        objCom = New ComSocketUdp("127.0.0.1", 10000, 10001, 0)
        'MsgBox("avant threadc")
        t = New Thread(AddressOf ThreadProc)
        'lance le thread de boucle de rception
        'MsgBox("aprs new thread")
        t.Start()
        'MsgBox("aprs thread start")
        'lblEtat.Text = "Communication dmarre - en attente..."
    End Sub

    Sub StopCapture()

        Dim retour_envoi As String

        If (Not objCom Is Nothing) Then
            retour_envoi = objCom.Envoyer("stop")
            'If (retour_envoi Is Nothing) Then
            'txtConsole.AppendText(vbCrLf & retour_envoi)
            'Else
            'txtConsole.AppendText(vbCrLf & "Commande -stop- envoye  CamStudio")
            'lblEtat.Text = "Stop - Capture stope"
            'End If
            'Else
            'MsgBox("Veuillez dmarrer la communication avant d'envoyer des commandes.")
        End If

    End Sub

    Sub Closing()

        'stoppe la rception sur l'objet
        If (Not objCom Is Nothing) Then objCom.StopperReception()

        'stoppe le thread de rception
        If (Not t Is Nothing) Then t.Abort()

    End Sub

End Module
